//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "konvex.h"
#include "math.h"
#include <stdio.h>
//---------------------------------------------------------------------------

#pragma package(smart_init)

konv_obal::konv_obal()
{
  pocet=0;
}
//---------------------------------------------------------------------------

void konv_obal::pridaj(bod b)
{
  if(pocet>100){
    Application->MessageBox("Vea bodov v konvexnom obale","hotovo",MB_OK);
    abort();
    };

  body[pocet]=b;
  pocet+=1;
}
//---------------------------------------------------------------------------

bool konv_obal::je_vnutri(bod b)
{
  int i,j;
  bool result=false;
  int poc=0;

  if(pocet<=2)return false;

  for(i=1;i<pocet;i++)
    for(j=i+1;j<pocet;j++)
      if(!result)result=je_v_trojuh(body[0],body[i],body[j],b);

  if(result)return true;

  for(i=0;i<pocet;i++)
    for(j=i+1;j<pocet;j++)
      if(je_v_usecke(body[i],body[j],b))poc+=1;

  if(poc>=2)result=true;

  return result;
}
//---------------------------------------------------------------------------

bool konv_obal::je_v_usecke(bod t1, bod t2, bod b)
{
  float tx,ty,tz;
  float t=-1;
  bool prep=false;
  t1.y=0;
  t2.y=0;
  b.y=0;

  if(fabs(t2.x-t1.x)>eps){
    t=(b.x-t1.x)/(t2.x-t1.x);
    prep=true;
    }
  else
    if(fabs(t2.x-b.x)>eps)return false;

  if(fabs(t2.y-t1.y)>eps){
    ty=(b.y-t1.y)/(t2.y-t1.y);
    if(prep){
      if(fabs(ty-t)>eps)return false;
      }
    else {
      t=ty;
      prep=true;
      };
    }
  else
    if(fabs(t2.y-b.y)>eps)return false;

  if(fabs(t2.z-t1.z)>eps){
    tz=(b.z-t1.z)/(t2.z-t1.z);
    if(prep){
      if(fabs(tz-t)>eps)return false;
      }
    else {
      t=tz;
      prep=true;
      };
    }
  else
    if(fabs(t2.z-b.z)>eps)return false;

  if(!prep)return false;

  if(t<eps)return false;
  if(t>1-eps)return false;

  return true;
}
//---------------------------------------------------------------------------
                                                                           
bool konv_obal::je_v_trojuh(bod t1, bod t2, bod t3, bod b)
{
  float vzdbt1, vzdbt2, vzdbt3, vzdt1t2, vzdt1t3, vzdt2t3;
  float uh1, uh2, uh3;
  float div1, div2, div3;
  float pom1, pom2, pom3;
//    FILE *logxx;

//  logxx=fopen("log.txt","a+");

  //vzdialenosti bodu b od bodov t1, t2, t3
  div1=(t1.x-b.x)*(t1.x-b.x)+(t1.z-b.z)*(t1.z-b.z);
  if(div1<0)
    div1=0;
  vzdbt1=sqrt(div1);
  div2=(t2.x-b.x)*(t2.x-b.x)+(t2.z-b.z)*(t2.z-b.z);
  if(div2<0)
    div2=0;
  vzdbt2=sqrt(div2);
  div3=(t3.x-b.x)*(t3.x-b.x)+(t3.z-b.z)*(t3.z-b.z);
  if(div3<0)
    div3=0;
  vzdbt3=sqrt(div3);

  if(fabs(vzdbt1)<eps)return false;
  if(fabs(vzdbt2)<eps)return false;
  if(fabs(vzdbt3)<eps)return false;

  vzdt1t2=sqrt((t2.x-t1.x)*(t2.x-t1.x)+(t2.z-t1.z)*(t2.z-t1.z));
  vzdt1t3=sqrt((t3.x-t1.x)*(t3.x-t1.x)+(t3.z-t1.z)*(t3.z-t1.z));
  vzdt2t3=sqrt((t2.x-t3.x)*(t2.x-t3.x)+(t2.z-t3.z)*(t2.z-t3.z));

  if((fabs(vzdt1t2)<eps) || (fabs(vzdt1t3)<eps) || (fabs(vzdt2t3)<eps))
    return false;

/*  fprintf(logxx,"vzdbt1: %f\n",vzdbt1);
  fprintf(logxx,"vzdbt2: %f\n",vzdbt2);
  fprintf(logxx,"vzdbt3: %f\n",vzdbt3);
  fprintf(logxx,"vzdt1t2: %f\n",vzdt1t2);
  fprintf(logxx,"vzdt1t3: %f\n",vzdt1t3);
  fprintf(logxx,"vzdt2t3: %f\n",vzdt2t3);
  fprintf(logxx,"eps %f\n",eps);

  fclose(logxx);
 */
  //uhly
  pom1=(vzdbt2*vzdbt2+vzdbt3*vzdbt3-vzdt2t3*vzdt2t3)/(2*vzdbt2*vzdbt3);
  pom2=(vzdbt1*vzdbt1+vzdbt3*vzdbt3-vzdt1t3*vzdt1t3)/(2*vzdbt1*vzdbt3);
  pom3=(vzdbt1*vzdbt1+vzdbt2*vzdbt2-vzdt1t2*vzdt1t2)/(2*vzdbt1*vzdbt2);
  if(pom1>1)pom1=1;
  if(pom1<-1)pom1=-1;
  if(pom2>1)pom2=1;
  if(pom2<-1)pom2=-1;
  if(pom3>1)pom3=1;
  if(pom3<-1)pom3=-1;
  uh1=acos(pom1);
  uh2=acos(pom2);
  uh3=acos(pom3);

  bool pom;

  pom=(uh1+uh2+uh3)>(2*M_PI-0.1);
  return pom;
}
