//---------------------------------------------------------------------------

#ifndef konvexH
#define konvexH

#include "deklaracie.h"
//---------------------------------------------------------------------------

/**
 * Jednoducha trieda na pracu s konvexnym obalom bodov.
 * Umoznuje zistovat, ci sa bod nachadza v konvexnom obale nejakych bodov
 */ 
class konv_obal
{
 private:
  /**
   * Pole bodov, z ktorych sa bude pouzivat konvexny obal
   */ 
  bod body[110];

  /**
   * Pocet bodov v poli body
   */ 
  int pocet;

 public:
  /**
   * Konstruktor.
   * vyrobi prazdny objekt, pocet bodov je 0
   */ 
  konv_obal();

  /**
   * Prida bod do pola bodov.
   * @param b bod, ktory sa pridava
   */ 
  void pridaj(bod b);

  /**
   * Zistuje, ci sa nejaky bod nachadza vnutri konvexneho obalu bodov v poli body
   * @param b bod, ktory sa testuje, ci je v obale
   * @return true, ak sa dany bod nachadza v obale
   */ 
  bool je_vnutri(bod b);
  
 private:
  /**
   * Metoda na zistenie, ci sa nejaky bod nechadza v trojuholniku urcenom troma bodmi
   * @param t1 prvy vrchol trojuholnika
   * @param t2 druhy vrchol trojuholnika
   * @param t3 treti vrchol trojuholnika
   * @param b bod, ktory sa ma testovat
   * @return true, ak sa bod nachadza v trojuholniku
   */ 
  bool je_v_trojuh(bod t1, bod t2, bod t3, bod b); //zistuje, co je bod b v trojuholniku urcenom bodmi t1, t2, t3

  /**
   * Metoda na zistenie, ci sa bod nachadza na usecke urcenej dvoma bodmi
   * @param t1 prvy bod usecky
   * @param t2 druhy bod usecky
   * @return true, ak sa bod nachadza na usecke
   */ 
  bool je_v_usecke(bod t1, bod t2, bod b);         //ci bod b lezi na usecke t1,t2
};

#endif
