//---------------------------------------------------------------------------
#pragma hdrstop

#include "deklaracie.h"
#include "matica.h"


//---------------------------------------------------------------------------

#pragma package(smart_init)

matica::matica(float *vstup)
{
  int i,j;

  for(i=0;i<3;i++)
    for(j=0;j<3;j++)
      data[i][j]=vstup[i*3+j];
}

matica::matica()
{
  int i,j;

  for(i=0;i<3;i++)
    for(j=0;j<3;j++)
      data[i][j]=0;
}

void matica::vynasob(float x)
{
  int i,j;

  for(i=0;i<3;i++)
    for(j=0;j<3;j++)
      data[i][j]*=x;
}

matica* matica::vynasob_sprava(matica *a)
{
  int i,j,k;
  matica *m;  //vysledna matica

  m=new matica();

  for(i=0;i<3;i++)
    for(j=0;j<3;j++)
      for(k=0;k<3;k++)
        m->data[i][j]+=data[i][k]*a->data[k][j];

  return m;
}

vektor matica::vynasob_vektorom(vektor v)
{
  int i,j;
  vektor pom;

  for(i=0;i<3;i++)pom.data[i]=0;

  for(i=0;i<3;i++)
    for(j=0;j<3;j++)
      pom.data[i]+=v.data[j]*data[j][i];

  return pom;
}

float matica::determinant()
{
  float plus,minus;

  plus=data[0][0]*data[1][1]*data[2][2]+
       data[0][1]*data[1][2]*data[2][0]+
       data[0][2]*data[1][0]*data[2][1];
  minus=data[0][2]*data[1][1]*data[2][0]+
        data[0][0]*data[1][2]*data[2][1]+
        data[0][1]*data[1][0]*data[2][2];

  return plus-minus;
}
